#include "StdAfx.h"
#include "GameTalkAPIGlobal.h"
#include "MainActor.h"
#include "UtilFunction.h"


CMainActor::CMainActor() 
	:	CActor(NULL)	// ݵ NULL ־ !, MainActor θ NULL.
{

}	

CMainActor::~CMainActor(void)
{

}


void CMainActor::NotifyActorDeletion(CActor *pActor)
{
	//CGTLifeLog log(__FUNCTION__);

	//////////////////////////////////////////////
	// CActor Observer
	//CRITICAL_SECTION * pCSActor = m_listObserver_Actor.GetCriticalSection();
	//EnterCriticalSection(pCSActor);

	CGTObserved<CActor>::listobserver_t observers;
	m_listObserver_Actor.GetObservers(&observers);
	CGTObserved<CActor>::listobserver_t::iterator it = observers.begin();

	for (; it != observers.end(); ++it)
	{
		_IGTActorManagementEvent *pObserver = static_cast<_IGTActorManagementEvent *>(*it);
		pObserver->OnGTManagementEvent_DeleteActor(pActor);
	}

	//LeaveCriticalSection(pCSActor);

	//////////////////////////////////////////////
	// CManager Observer
	//CRITICAL_SECTION * pCSManager = m_listObserver_Manager.GetCriticalSection();
	//EnterCriticalSection(pCSManager);

	CGTObserved<CManager>::listobserver_t observers2;
	m_listObserver_Manager.GetObservers(&observers2);
	CGTObserved<CManager>::listobserver_t::iterator it2 = observers2.begin();

	for (; it2 != observers2.end(); ++it2)
	{
		_IGTActorManagementEvent *pObserver = static_cast<_IGTActorManagementEvent *>(*it2);
		pObserver->OnGTManagementEvent_DeleteActor(pActor);
	}

	//LeaveCriticalSection(pCSManager);
}

void CMainActor::NotifyMangerDeletion(CManager *pManager)
{
	//CGTLifeLog log(__FUNCTION__);

	//////////////////////////////////////////////
	// CActor Observer
	//CRITICAL_SECTION * pCSActor = m_listObserver_Actor.GetCriticalSection();
	//EnterCriticalSection(pCSActor);

	CGTObserved<CActor>::listobserver_t observers;
	m_listObserver_Actor.GetObservers(&observers);
	CGTObserved<CActor>::listobserver_t::iterator it = observers.begin();

	for (; it != observers.end(); ++it)
	{
		_IGTActorManagementEvent *pObserver = static_cast<_IGTActorManagementEvent *>(*it);
		pObserver->OnGTManagementEvent_DeleteManager(pManager);
	}

	//LeaveCriticalSection(pCSActor);


	//////////////////////////////////////////////
	// CManager Observer
	//CRITICAL_SECTION * pCSManager = m_listObserver_Manager.GetCriticalSection();
	//EnterCriticalSection(pCSManager);

	CGTObserved<CManager>::listobserver_t observers2;
	m_listObserver_Manager.GetObservers(&observers2);
	CGTObserved<CManager>::listobserver_t::iterator it2 = observers2.begin();

	for (; it2 != observers2.end(); ++it2)
	{
		_IGTActorManagementEvent *pObserver = static_cast<_IGTActorManagementEvent *>(*it2);
		pObserver->OnGTManagementEvent_DeleteManager(pManager);
	}

	//LeaveCriticalSection(pCSManager);
}


void CMainActor::RegisterActor(CActor *pOb)
{
	m_listObserver_Actor.RegisterObserver(pOb);
}


void CMainActor::UnRegisterActor(CActor *pOb)
{
	m_listObserver_Actor.UnRegisterObserver(pOb);
}


void CMainActor::RegisterManager(CManager *pOb)
{
	m_listObserver_Manager.RegisterObserver(pOb);
}


void CMainActor::UnRegisterManager(CManager *pOb)
{
	m_listObserver_Manager.UnRegisterObserver(pOb);
}